#--------------------------- httpd.pl --------------------------
#! /usr/local/bin/perl
#
#   Micro Clipboard Server
#
#   (was)
#   "Cheap" HTTPD for Windows 95/NT (or even "unix"es).
#
#   viciously hacked! Only responds to /clipthis.cgi

#   use: start inetd_clip 85 "perl clipd.pl"
#

use Win32::Clipboard;

$server = 'Cheap-HTTPD/1.3.1' ;

$log = 1 ;
binmode(STDOUT) ;
$NL = "\n" ;
#print "Connection from ".$ENV{"CONNECTION"}.$NL ;
$connection = $ENV{"CONNECTION"} ;
($remhost,$remport,$localhost,$localport) = split(/ /,$connection) ;
#print STDERR "Session PID $$ ".&filetime(time)." from $remhost\n" ;
print STDERR "Session PID $$ ".&filetime(time)." from $remhost\n" ;
$get_line = '';
$target_host = '';
$log = 0 ;
while (<STDIN>)  {
    print STDERR if ($log) ;
    s/[\r\n]//g ;
    if ($_ eq "")  {
        last ;
    }
    if (/^get/i)  {
        $get_line = $_;
    }
    if (/^Host[:]\s*(\S+)/i)  {
        $target_host = $1;
    }
}

if ($get_line ne '') {
    ($cmd,$url) = split(/ +/,$get_line) ;
    ($targ_lower = $target_host) =~ tr/[A-Z]/[a-z]/ ;
    $s = $SITE_MAP{$targ_lower};
    $http = $s if ($s ne '');
    $url =~ s=\.\.[/\\]=/=g ;           # ../ -> /
    if (substr($url,0,1) ne "/")  {
        $url = "/".$url ;
    }
    if ($url =~ /[\\\/]$/)  {	# removing trailing slash
	$has_slash = 1;
        chop $url ;
    } else {
        $has_slash = 0;
    }
    #
    # if it looks like a cgi script, then strip the arguments off of
    # the URL name before we traverse it.
    #
    if ($url =~ /(([^?]*\/cgi\-bin\/[^?]+)|(.*\.cgi))/i)  {
        $script_name = $1 ;
        $cgi_args = substr($url, length($script_name)+1) ;
        $url = $script_name ;           # isolate URL
#        print STDERR "CGI=$url ARGS=$cgi_args\n" ;
        $cgi = 1 ;
    }
    else  {
#        print STDERR "URL=$url\n" ;
        $cgi = 0 ;
    }
    $filename = $url;
print STDERR "$filename\n" ;
#    print STDERR "Sending $filename\n" if ($log) ;


#
# form to "get" text to insert to clipboard
# 
    if ($cgi && ($filename eq "/clipthis.cgi"))  {           # CGI script
        $ENV{"QUERY_STRING"} = $cgi_args ;
        $ENV{"SERVER_SOFTWARE"} = $server ;
        $ENV{"REMOTE_ADDR"} = $remhost ;
        $ENV{"REMOTE_PORT"} = $remport ;
        $ENV{"SERVER_ADDR"} = $localhost ;
        $ENV{"SERVER_PORT"} = $localport ;
        $ENV{"SCRIPT_NAME"} = $script_name ;
        if ($cgi_args ne "")  {         # arguments to handle
            (@xargs) = split(/\&/,$cgi_args) ;   # split it
            foreach $arg (@xargs)  {    # for each one
                $arg =~ s/\%([0-9a-z][0-9a-z])/pack(C,hex($1))/ieg ;
                ($es,$ev) = split(/=/,$arg) ;
		$ev =~ s|\+|\ |g;
                $Q{$es} = $ev ;     # put into environment
            }
        }
        &do_header('',0) ;
        $| = 1 ;
#        require "$filename" ;

###
# additions

if ($Q{'clipthis'}) {
  Win32::Clipboard::Set($Q{'clipthis'});
}

print "Content-type: text/html\n\n"; 
print '<html><head><title>clipthis form</title></head><body bgcolor=white>';

if ($Q{'clipthis'}) {
    print "ok<br>\n";
} else {
    print "yeah?<br>\n";
}

print '
<form method=get>
<textarea name=clipthis cols=40 rows=15></textarea><br>
<input type=submit value="put in clipboard">
</form>
<p><a href="getclip.cgi">view text in clipboard</a></p>

</body></html>';

###
#	print STDERR "$filename\n";
    } elsif ($cgi && ($filename eq "/getclip.cgi"))  {           # CGI script
        $ENV{"QUERY_STRING"} = $cgi_args ;
        $ENV{"SERVER_SOFTWARE"} = $server ;
        $ENV{"REMOTE_ADDR"} = $remhost ;
        $ENV{"REMOTE_PORT"} = $remport ;
        $ENV{"SERVER_ADDR"} = $localhost ;
        $ENV{"SERVER_PORT"} = $localport ;
        $ENV{"SCRIPT_NAME"} = $script_name ;
        if ($cgi_args ne "")  {         # arguments to handle
            (@xargs) = split(/\&/,$cgi_args) ;   # split it
            foreach $arg (@xargs)  {    # for each one
                $arg =~ s/\%([0-9a-z][0-9a-z])/pack(C,hex($1))/ieg ;
                ($es,$ev) = split(/=/,$arg) ;
		$ev =~ s|\+|\ |g;
                $Q{$es} = $ev ;     # put into environment
            }
        }
        &do_header('',0) ;
        $| = 1 ;
#        require "$filename" ;

###
# additions

#if ($Q{'clipthis'}) {
#  Win32::Clipboard::Set($Q{'clipthis'});
#}

$cliptext = Win32::Clipboard::GetText();

print "Content-type: text/html\n\n"; 
print '<html><head><title>clipboard text</title></head><body bgcolor=white>';


print "<h4>clipboard text</h4>

<pre>---

$cliptext

---</pre>

<p><a href='clipthis.cgi'>put text into clipboard</a></p>
</body></html>";

###
#	print STDERR "$filename\n";
    } else  {

#	print "Content-type: image/gif\n\n";

# this was my anti banner ad hack
#   

#	open (F,"<space_w1h4.gif");
#	binmode(F);
#        $ctype = "gif" ;
#        &do_header((defined $CONTENT{$ctype}) ? $CONTENT{$ctype} :
#            $CONTENT{'txt'},-1) ;

#	print while (<F>);
#	close(F);


      print STDERR "Can't open $url\n" if ($log) ;
      print "HTTP/1.0 404 Object Not Found\n" ;
      print "Content-type: text/html\n\n" ;
      print "<BODY><h1>HTTP/1.0 404 Object Not Found</h1></BODY></html>\n" ;
    }
}
exit(0);

sub filetime  {
    ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) =
        localtime(@_[0]) ;
    sprintf("%04d/%02d/%02d %02d:%02d:%02d",$year+1900,$mon+1,$mday,$hour,$min,$sec) ;
}

sub gmtime  {
    ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) =
        gmtime(@_[0]) ;
    $monx = ('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec')[$mon];
    $wdayx = ('Sun','Mon','Tue','Wed','Thu','Fri','Sat')[$wday];
    # Wed, 25 Feb 1998 22:05:53 GMT
    return sprintf("%s, %d %s %d %02d:%02d:%02d GMT",$wdayx,$mday,$monx,$year+1900,$hour,$min,$sec) ;
}

sub start_header {
    local($response) = @_ ;

    (@stats) = stat($filename) ;
    $ftime = &filetime($stats[9]) ;
    $fsize = $stats[7] ;
    $ftime = &gmtime($stats[9]) ;
    $now = &gmtime(time) ;
    print "$response\n" ;
    print "Date: $now\n" ;
    print "Server: NCSA/1.4.2\n" ;
    ####print "Server: $server\n" ;
}

sub do_header {
    local($type, $size) = @_ ;

    &start_header("HTTP/1.0 200 Document follows") ;
    print "Date: $now\n" ;
    print "Server: NCSA/1.4.2\n" ;
    ####print "Server: $server\n" ;
    if (0) {
    	print 'ETag: "3421d78-9a6a-34fb8ee7"'."\n";
    	print 'Accept-Ranges: bytes'."\n";
    }
    if ($size < 0) {
        print "Last-modified: $ftime\n" ;
        print "Content-length: $fsize\n" ;
    } elsif ($size > 0) {
        print "Content-length: $size\n" ;
    }
    print "Content-type: $type\n\n" if ($type ne '') ;

    # note: a cgi is assigned $type='' so the cgi script does the header.
}

